unit Findfile;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils, Dialogs, Menus, Messages, TAUtils, FileCtrl,
  Mask,Clipbrd, Tscnfile;

type
  TFindFileDlg = class(TForm)
    OKBtn: TBitBtn;
    Bevel1: TBevel;
    FileToFind: TEdit;
    Label1: TLabel;
    ADrive: TCheckBox;
    BDrive: TCheckBox;
    CDrive: TCheckBox;
    DDrive: TCheckBox;
    EDrive: TCheckBox;
    FDrive: TCheckBox;
    GDrive: TCheckBox;
    HDrive: TCheckBox;
    IDrive: TCheckBox;
    JDrive: TCheckBox;
    KDrive: TCheckBox;
    LDrive: TCheckBox;
    MDrive: TCheckBox;
    NDrive: TCheckBox;
    ODrive: TCheckBox;
    PDrive: TCheckBox;
    QDrive: TCheckBox;
    RDrive: TCheckBox;
    SDrive: TCheckBox;
    TDrive: TCheckBox;
    UDrive: TCheckBox;
    VDrive: TCheckBox;
    WDrive: TCheckBox;
    XDrive: TCheckBox;
    YDrive: TCheckBox;
    ZDrive: TCheckBox;
    FoundFilesListBox1: TListBox;
    SearchBtn1: TBitBtn;
    PopupMenu1: TPopupMenu;
    EditFile1: TMenuItem;
    SearchString: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    DirTreeLimit: TEdit;
    FileAgeLimit: TEdit;
    Label6: TLabel;
    CopytoClipboard1: TMenuItem;
    Label7: TLabel;
    FileSizeLimit: TEdit;
    GroupBox1: TGroupBox;
    FoundFileNo: TLabel;
    IncSubDirCB: TCheckBox;
    CaseSenseCB: TCheckBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Search1: TMenuItem;
    FindFile1: TMenuItem;
    GetDirectory1: TMenuItem;
    SpeedButton1: TSpeedButton;
    FileAgeComp1: TComboBox;
    FileSizeComp1: TComboBox;
    FileScan1: TFileScan;
    ShowSizeCB: TCheckBox;
    ShowDateCB: TCheckBox;
    ShowAttrCB: TCheckBox;
    Label5: TLabel;
    SearchProgressPanel1: TPanel;
    SearchHeaderLabel1: TLabel;
    SearchLabel1: TLabel;
    procedure SearchBtn1Click(Sender: TObject);
    procedure FoundFilesListBox1DblClick(Sender: TObject);
    procedure EditFile1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure CopytoClipboard1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FindFile1Click(Sender: TObject);
    procedure GetDirectory1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton1Click(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FindFileDlg               :TFindFileDlg;
  NumberofFilesFound        :Integer;
  DateStr, TimeStr          :String;
  TempFloat                 :Double;
implementation
Uses Main, FileUtil;

{$R *.DFM}

procedure TFindFileDlg.SearchBtn1Click(Sender: TObject);
var
   SearchPath, TempString                      :String;
   StartComponent, EndComponent, i, MaxSize    :Integer;
   BreakPoint, j                               :Integer;
   FileAgeLimitInt, FileSizeLimitInt           :LongInt;

function GetFileCompType(Const InStr :String):TFileCompType;
Begin
     If InStr = '='  Then Result := FctEqual;
     If InStr = '>'  Then Result := FctGreaterThan;
     If InStr = '<'  Then Result := FctLessThan;
     If InStr = '>=' Then Result := FctGreaterThanorEqual;
     If InStr = '<=' Then Result := FctLessThanorEqual;
     If ((InStr <> '=')
     and (InStr <> '<')
     and (InStr <> '>')
     and (InStr <> '<=')
     and (InStr <> '>=')) then Result := FctNone;
End;

Procedure ScanTheFile(Const SearchPath :String);
Begin
     SearchLabel1.Visible         := True;
     SearchHeaderLabel1.Visible   := True;
     SearchHeaderLabel1.Repaint;
     SearchLabel1.Caption         := SearchPath;
     FileScan1.Directory          := SearchPath;
     FileScan1.FileSpecs          := FileToFind.Text;
     FileScan1.IncSubDir          := IncSubDirCB.Checked;
     FileScan1.SearchString       := SearchString.Text;
     FileScan1.CaseSense          := CaseSenseCB.Checked;
     FileScan1.ShowSize           := ShowSizeCB.Checked;
     FileScan1.ShowDate           := ShowDateCB.Checked;
     FileScan1.ShowAttr           := ShowAttrCB.Checked;

     If (FindFileDlg.FileAgeLimit.Text <> '') then begin
       FileScan1.FileAge          := FileAgeLimitInt;
       FileScan1.FileAgeComp      := GetFileCompType(FileAgeComp1.Text);
     End Else Begin
       FileScan1.FileAge          := 0;
       FileScan1.FileAgeComp      := fctNone;
     End;
     If (FindFileDlg.FileSizeLimit.Text <> '') then begin
       FileScan1.FileSize         := FileSizeLimitInt;
       FileScan1.FileSizeComp     := GetFileCompType(FileSizeComp1.Text);
     End Else Begin
       FileScan1.FileSize         := 0;
       FileScan1.FileSizeComp     := fctNone;
     End;
     { Now perform the scan !!}
     FileScan1.StartScan          := True;
     SearchLabel1.Visible         := False;
     SearchHeaderLabel1.Visible   := False;

End;

begin
    Interrupt_Flag      := False;
    FoundFileNo.Caption := '';
    NumberofFilesFound  := 0;
    FoundFilesListBox1.Clear;

    If FindFileDlg.FileAgeLimit.Text <> '' then
      FileAgeLimitInt  := StrtoInt(Copy(FindFileDlg.FileAgeLimit.Text,1,Length(FindFileDlg.FileAgeLimit.Text)));
    If FindFileDlg.FileSizeLimit.Text <> '' then
      FileSizeLimitInt := StrtoInt(Copy(FindFileDlg.FileSizeLimit.Text,1,Length(FindFileDlg.FileSizeLimit.Text)));


    Try
      Screen.Cursor  := crHourGlass;
{ Start the Find - Loop for Each Drive Checked  }
{                  Then Loop for Each Directory }
      StartComponent := ADrive.ComponentIndex;
      EndComponent   := ZDrive.ComponentIndex;

{ If the DirTreeLimit file is empty - then search all selected drives
     otherwise - limit search to selected directory tree ( and sub branches) }
      If DirTreeLimit.Text = '' then begin
        IncSubDirCB.Checked   := True;
        FileScan1.AppendItems := False;
        For i := StartComponent to EndComponent Do begin
          If TCheckBox(Components[i]).Checked = True then Begin
            ScanTheFile(TCheckBox(Components[i]).Caption + '\');
            FileScan1.AppendItems := True;
          End;
        End;
        { Copy the Results from the scan to the SearchResults List Box }
        FoundFilesListBox1.items.SetText(FileScan1.ScanResult.GetText);
        FileScan1.AppendItems := False;
        FileScan1.ScanResult.Clear;
      End Else Begin
        FileScan1.AppendItems := False;
        ScanTheFile(PostFixDir(DirTreeLimit.Text));
        { Copy the Results from the scan to the SearchResults List Box }
        FoundFilesListBox1.items.SetText(FileScan1.ScanResult.GetText);
      End;

{ Now - find the longest Directory String and then make all of the dir strings the same
  Size - so that the Size and Date LineUp correctly }
{ Only do this resizing if extra info has been selected to be shown }
      If ShowSizeCB.Checked
      or ShowDateCB.Checked
      or ShowAttrCB.Checked Then Begin

      With FoundFilesListBox1 do Begin
        { Now prevent drawing to the list box until updates are done }
        Items.BeginUpdate;
        i := items.count;
        MaxSize := 0;
        For i := 0 to (Items.Count - 1) do begin
           If Pos(' ', Items.Strings[i]) > MaxSize then begin
              MaxSize := Pos(' ', Items.Strings[i]);
           End;
        End;


{ Should put a message - telling user that list box is being formatted }
        For i := 0 to (Items.Count - 1) do begin
          If items.Strings[i][1] <> '*' then begin
            BreakPoint := POS(' ', Items.Strings[i]);
            TempString := Copy(Items.Strings[i], (BreakPoint), Length(Items.Strings[i]));
            Items.Strings[i] := Copy(Items.Strings[i], 1, (BreakPoint - 1));

            For j := BreakPoint to MaxSize do begin
              Items.Strings[i] := Items.Strings[i] + ' ';
            end;
            Items.Strings[i] := Items.Strings[i] + ' ' + TempString;

 {Check to see if the user wishes to interrupt the application }
            Application.ProcessMessages;
            If Interrupt_Flag Then Begin
              FoundFilesListBox1.Clear;
              FoundFilesListBox1.Items.Add('*** Search Aborted - List has been Cleared ***');
              Exit;
            End;

          End;
        End;
        { Now update the list box }
        Items.EndUpdate;
      End;
      End;
     Finally
      SendMessage(FoundFilesListBox1.Handle, LB_SETHORIZONTALEXTENT, 1000, 0);
      If Not Interrupt_Flag then begin
        TempFloat           := FoundFilesListBox1.Items.Count;
        FoundFileNo.Caption := StripSpacesInFront(Format('%6.0n',[TempFloat]));
      End Else Begin
        FoundFileNo.Caption := '0';
      End;
      Interrupt_Flag := False;
      Screen.Cursor := crDefault;
    End;
end;


procedure TFindFileDlg.FoundFilesListBox1DblClick(Sender: TObject);
var
   FiletoEdit, DefaultDir                                 :String;
begin
   FileToEdit := FindFileDlg.FoundFilesListBox1.Items[FoundFilesListBox1.ItemIndex];
   DefaultDir := '';
   { Now Strip out all other info except for File Name and path }
   FiletoEdit := Copy(FiletoEdit, 1, POS(' ',FiletoEdit));
   Execute('NotePad.exe',FiletoEdit,DefaultDir, SW_SHOW);
end;


procedure TFindFileDlg.EditFile1Click(Sender: TObject);
begin
   FoundFilesListBox1DblClick(Sender);
end;

procedure TFindFileDlg.BitBtn1Click(Sender: TObject);
var
   Dir        :String;
   HelpCtx    :LongInt;
begin
   HelpCtx   := 0;
   Dir := 'C:\';
   if SelectDirectory(Dir,[], HelpCtx) then begin
      DirTreeLimit.Text := Dir;
   End;

end;

procedure TFindFileDlg.CopytoClipboard1Click(Sender: TObject);
begin
    ClipBoard.SetTextBuf(FoundFilesListBox1.Items.GetText);
end;


procedure TFindFileDlg.FormActivate(Sender: TObject);
begin
   ActiveControl       := FileToFind;
end;


procedure TFindFileDlg.Exit1Click(Sender: TObject);
begin
     Close;
end;

procedure TFindFileDlg.FindFile1Click(Sender: TObject);
begin
     SearchBtn1Click(Sender);
end;

procedure TFindFileDlg.GetDirectory1Click(Sender: TObject);
begin
     SpeedButton1Click(Sender);
end;

procedure TFindFileDlg.FormKeyPress(Sender: TObject; var Key: Char);
begin
     CheckforInterrupt(Key, 'FindFile');
end;

procedure TFindFileDlg.SpeedButton1Click(Sender: TObject);
var
   Dir        :String;
   HelpCtx    :LongInt;
begin
   HelpCtx   := 0;
   Dir := 'C:\';
   if SelectDirectory(Dir,[], HelpCtx) then begin
      DirTreeLimit.Text := Dir;
   End;

end;

procedure TFindFileDlg.OKBtnClick(Sender: TObject);
begin
   Close;
end;

procedure TFindFileDlg.FormCreate(Sender: TObject);
var
   Drive, StartComponent, i      :Integer;
begin
    Drive := Ord('c') - Ord('a');

    StartComponent := ADrive.ComponentIndex;
    for i := 0 to 25 do begin
      TCheckBox(Components[i + StartComponent]).Checked := False;
      If GetDriveType(i) <> 0 then Begin
         TCheckBox(Components[i + StartComponent]).Visible := True;
         If Drive = i then Begin
            TCheckBox(Components[i + StartComponent]).Checked := True;
         End Else Begin
            TCheckBox(Components[i + StartComponent]).Checked := False;
         End;
      End Else Begin
         TCheckBox(Components[i + StartComponent]).Visible := False;
      End;
    end;
end;

end.
